import type { Uint8ArrayList } from 'uint8arraylist';
export declare enum CODEC_TYPES {
    VARINT = 0,
    BIT64 = 1,
    LENGTH_DELIMITED = 2,
    START_GROUP = 3,
    END_GROUP = 4,
    BIT32 = 5
}
export interface EncodeFunction<T> {
    (value: T): Uint8Array | Uint8ArrayList;
}
export interface DecodeFunction<T> {
    (buf: Uint8ArrayList, offset: number): T;
}
export interface EncodingLengthFunction<T> {
    (value: T): number;
}
export interface Codec<T> {
    name: string;
    type: number;
    encode: EncodeFunction<T>;
    decode: DecodeFunction<T>;
    encodingLength: EncodingLengthFunction<T>;
}
export declare function createCodec<T>(name: string, type: number, encode: EncodeFunction<T>, decode: DecodeFunction<T>, encodingLength: EncodingLengthFunction<T>): Codec<T>;
//# sourceMappingURL=codec.d.ts.map