import { Uint8ArrayList } from 'uint8arraylist';
import { createCodec, CODEC_TYPES } from './codec.js';
const encodingLength = function int64EncodingLength(val) {
    return 8;
};
const encode = function int64Encode(val) {
    const buf = new Uint8ArrayList(new Uint8Array(encodingLength(val)));
    buf.setBigInt64(0, val, true);
    return buf;
};
const decode = function int64Decode(buf, offset) {
    return buf.getBigInt64(offset, true);
};
export const fixed64 = createCodec('fixed64', CODEC_TYPES.BIT64, encode, decode, encodingLength);
//# sourceMappingURL=fixed64.js.map