import { signed } from '../utils/varint.js';
import { createCodec, CODEC_TYPES } from './codec.js';
const encodingLength = function int32EncodingLength(val) {
    return signed.encodingLength(val);
};
const encode = function int32Encode(val) {
    const buf = new Uint8Array(encodingLength(val));
    signed.encode(val, buf);
    return buf;
};
const decode = function int32Decode(buf, offset) {
    return signed.decode(buf, offset);
};
export const int32 = createCodec('int32', CODEC_TYPES.VARINT, encode, decode, encodingLength);
//# sourceMappingURL=int32.js.map