import { zigzag } from '../utils/varint.js';
import { createCodec, CODEC_TYPES } from './codec.js';
const encodingLength = function sint32EncodingLength(val) {
    return zigzag.encodingLength(val);
};
const encode = function svarintEncode(val) {
    const buf = new Uint8Array(encodingLength(val));
    zigzag.encode(val, buf);
    return buf;
};
const decode = function svarintDecode(buf, offset) {
    return zigzag.decode(buf, offset);
};
export const sint32 = createCodec('sint32', CODEC_TYPES.VARINT, encode, decode, encodingLength);
//# sourceMappingURL=sint32.js.map